<?php

//
// Copyright (C) 2013, 2014 FromDual GmbH
//
// This program is commercial software. Use of this software is governed
// by your applicable license agreement with FromDual GmbH
//

/*

  printCrontabFile()
  putTaskIntoCrontabFile($pTask)
  loadCrontabFromFile($pCrontabTmpFile)
  findTaskInCrontabFile($pTask)
  dumpCrontabToFile($pCrontabTmpFile)

*/

//   $this->lCrontabTmpFile = dirname($_SERVER['SCRIPT_FILENAME']) . '/tmp/crontab.tmp';
//   $this->lCheckNodesTask = dirname($_SERVER['SCRIPT_FILENAME']) . '/bin/check_nodes.php';

// No require/included here!

// ---------------------------------------------------------------------
function printCrontabFile()
// ---------------------------------------------------------------------
{

  $cmd = "crontab -l 2>&1";
  $stdout = exec($cmd, $output, $ret);
  if ( $ret != 0 ) {
    throw new Exception($stdout);
  }
  else {
    return $output;
  }
}

// ---------------------------------------------------------------------
function putTaskIntoCrontabFile($pTask)
// ---------------------------------------------------------------------
{

  if ( findTaskInCrontabFile($pTask) === true ) {
    throw new Exception('Task is already in crontab file.');
  }

  $lCrontabTmpFile = dirname($_SERVER['SCRIPT_FILENAME']) . '/tmp/crontab.tmp';
  $lCheckNodesTask = dirname($_SERVER['SCRIPT_FILENAME']) . '/bin/check_nodes.php';

	list($ret, $msg) = dumpCrontabToFile($lCrontabTmpFile);

  if ( $ret != OK ) {

    // no crontab so we touch it
    $fh = @fopen($lCrontabTmpFile, 'w');
    if ( $fh === false ) {
      // todo: how is the correct error message?
      throw new Exception('Cannot create file ' . $lCrontabTmpFile . ' Missing privileges?');
    }
    fclose($fh);
  }

  $fh = fopen($lCrontabTmpFile, 'a+');
  fputs($fh, "#\n");
  fputs($fh, "# MOC node check job\n");
  fputs($fh, "#\n");
  fputs($fh, "*  *  *  *  *  " . $lCheckNodesTask . "\n");
  fputs($fh, "#\n");
  fclose($fh);
  loadCrontabFromFile($lCrontabTmpFile);
}

// ---------------------------------------------------------------------
function loadCrontabFromFile($pCrontabTmpFile)
// ---------------------------------------------------------------------
{

  $cmd = "crontab $pCrontabTmpFile";
  $stdout = exec($cmd, $output, $ret);
  if ( $ret != 0 ) {
    print "$stdout<br />\n";
  }
}

// ---------------------------------------------------------------------
function findTaskInCrontabFile($pTask)
// ---------------------------------------------------------------------
{

  $lCrontabTmpFile = dirname($_SERVER['SCRIPT_FILENAME']) . '/tmp/crontab.tmp';

	list($ret, $msg) = dumpCrontabToFile($lCrontabTmpFile);

  if ( $ret != OK ) {
    $rc = 879;
    print $msg . " (rc=$rc)\n";
    return false;
  }

  try {
    $fh = fopen($lCrontabTmpFile, 'r');
  }
  catch (Exception $e) {
    $rc = 878;
    throw new Exception($e->getMessage() . " (rc=$rc)");
  }

  while ( ($line = fgets($fh)) ) {

    $pattern = '#.*' . $pTask . '.*#';

    if ( preg_match($pattern, $line, $matches) ) {
      fclose($fh);
      return true;
    }
  }
  fclose($fh);
  return false;
}

// ---------------------------------------------------------------------
function dumpCrontabToFile($pCrontabTmpFile)
// ---------------------------------------------------------------------
{
  $rc = OK;
	$msg = '';

  $cmd = "crontab -l > " . $pCrontabTmpFile;
  $stdout = exec($cmd, $output, $ret);

  if ( $ret != 0 ) {

    // no crontab for httpd user
    if ( $ret == 1 ) {
			$rc = 800;
      $msg = 'Error dumping crontab occured. Empty crontab.';
    }
    else {
			$rc = 809;
      $msg = 'Error dumping crontab occured. For example permission denied.';
    }
  }

  return array($rc, $msg);
}

?>
