<?php

//
// Copyright (C) 2013, 2014 FromDual GmbH
//
// This program is commercial software. Use of this software is governed
// by your applicable license agreement with FromDual GmbH
//

/*

  setInstallationLevel($pLevel)
  getInstallationLevel()

*/

// No require/included here!
// require_once("lib/System.inc");

// none      - no file
// step_1    - step 1 completed: Requirement checks
// step_2    - step 2 completed: Configuration database
// step_3    - step 3 completed: ...
// ...
// completed - Installation completed

// ---------------------------------------------------------------------
function getInstallationLevel()
// ---------------------------------------------------------------------
{

  global $gMyNameBase;

  $file = $gMyNameBase . '/etc/' . 'installation.status';
  $level = 'none';

  if ( ! file_exists($file) ) {
    return $level;
  }

  if ( ! is_readable($file) ) {
    $level = 'error';
    print "<p>File $file does not exitor is not readable for user " . whoami() . ".</p>\n";
    return $level;
  }

  // read file
  try {
    $fh = fopen($file, 'r');
  }
  catch (Exception $e) {
    $rc = 703;
    print "<p>" . $e->getMessage() . " (rc=$rc).</p>\n";
    exit($rc);
  }

  if ( $fh !== false ) {
    $level = trim(fgets($fh));
    fclose($fh);
  }

  if ( $level == '' ) {
    $level = 'none';
  }

  return $level;
}

// ---------------------------------------------------------------------
function setInstallationLevel($pLevel)
// ---------------------------------------------------------------------
{

  global $gMyNameBase;

  $rc = OK;

  $file = $gMyNameBase . '/etc/' . 'installation.status';

  if ( ! file_exists($file) ) {

    // try to write file
    try {
      $fh = @fopen($file, 'w');
    }
    catch (Exception $e) {
      $rc = 702;
      print "<p>Error: " . $e->getMessage() . " (rc=$rc)</p>\n";
      return $rc;
    }
    if ( $fh !== false ) {
      fclose($fh);
    }
    else {
      $rc = 931;
      $err = error_get_last();
      print "<p>Error: " . $err['message'] . " (rc=$rc)<br />\n";
      print "Line: " . $err['line'] . ', ' . $err['file'] . "</p>\n";
      return $rc;
    }
  }

  // File exits for sure here
  if ( ! is_writable($file) ) {
    $rc = 700;
    print "<p>Cannot write to $file as user " . whoami() . " (rc=$rc)</p>\n";
    return $rc;
  }

  try {
    $fh = @fopen($file, 'w');
    fputs($fh, "$pLevel\n");
    fclose($fh);
  }
  catch (Exception $e) {
    $rc = 701;
    print "<p>Error: " . $e->getMessage() . " (rc=$rc)</p>\n";
    return $rc;
  }
  return $rc;
}

?>
