<?php

//
// Copyright (C) 2013, 2014 FromDual GmbH
//
// This program is commercial software. Use of this software is governed
// by your applicable license agreement with FromDual GmbH
//

require_once("lib/Install.inc");
require_once("lib/Repository.inc");

// ---------------------------------------------------------------------
if ( $hFunction == 'install' )
// ---------------------------------------------------------------------
{
  ?>
  <h1>Install system</h1>

  <h2>Check requirements</h2>

  <?php

  $level = getInstallationLevel();

  if ( $level == 'step_1' ) {
    print "<p>Installation level $level already completed. Skipping...</p>\n";
  }
  else {

		// Check for mod_rewrite module

		if ( ! in_array('mod_rewrite', apache_get_modules()) ) {
      ?>
			<p>Apache module <code>mod_rewrite</code> is missing.</p>
			<?php
		}


    // Check for encrypted https connection

		if ( ! empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443 ) {
			// noop;
		}
		else {
      ?>
			<p>You should use an encrypted https connection only.</p>
      <p>Enable SSL on <a href="https://help.ubuntu.com/12.04/serverguide/httpd.html#https-configuration" target="_blank" title="HTTPS Configuration">Ubuntu</a>.</p>
			<?php
		}


    //   var_dump(get_loaded_extensions());

    // todo: Do this in a loop

    if ( extension_loaded('posix') === false ) {
      print "<p>Extension posix is needed.<br />\n";
      print "Please install with:<br />\n";
      print "<pre>yum install php-posix</pre></p>\n";
      // On Ubunutu it seems to be default installed.
    }
    else {
      print "<p>Extension posix is installed.</p>\n";
    }

    if ( ! extension_loaded('PDO') ) {
      print "<p>Extension PDO is needed.<br />\n";
      print "Please install with:<br />\n";
      print "<pre>sudo apitude install ...</pre></p>\n";
    }
    else {
      print "<p>Extension PDO is installed.</p>\n";
    }

    print "<p>Available PDO drivers are:<br />\n";
    print "<ul>\n";
    $aDriver = PDO::getAvailableDrivers();
    $sqllite_found = false;
    foreach ( $aDriver as $driver ) {
      print "  <li>$driver</li>\n";
      if ( $driver == 'sqlite' ) {
        $sqllite_found = true;
      }
    }
    print "</ul></p>\n";

    if ( $sqllite_found === false ) {
      print "<p>SQLite driver is missing!<br />\n";
      print "Please install with:<br />\n";
      print "<pre>sudo aptitude install php5-sqlite3</pre></p>\n";
    }

    // Step 1: Requirement checks completed
    $rc = setInstallationLevel('step_1');

    if ( $rc != 0 ) {
      print "<p>Error: $rc</p>\n";
      exit($rc);
    }
  }

  ?>
  <h2>Install configuration database</h2>
  <?php

  $level = getInstallationLevel();
  if ( $level == 'step_2' ) {
    print "<p>Installation level $level already completed. Skipping...</p>\n";
  }
  else {

    print "<p>Create configuration database.</p>\n";
    $rc = createRepositoryDatabase();
    if ( $rc == 0 ) {
      print "<p>Configuration database successfully created.</p>\n";

      $rc = setInstallationLevel('step_2');
      if ( $rc != 0 ) {
        print "<p>Error: $rc</p>\n";
        exit($rc);
      }
    }
    else {
      print "<p>Problem creating configuration database.</p>\n";
    }
  }

/*  <h2>Install ...</h2>
  <p>...</p>
  <hr />*/
  ?>
  <p><input type="button" value="Continue" onclick="javascript:location.href='index.php';" /></p>
  <?php

  // Installation completed
  $rc = setInstallationLevel('completed');

  if ( $rc != 0 ) {
    print "<p>Error: $rc</p>\n";
    exit($rc);
  }
}
// ---------------------------------------------------------------------
else
// ---------------------------------------------------------------------
{
  print "Unkown function $hFunction";
}

?>
