<?php

//
// Copyright (C) 2013, 2014 FromDual GmbH
//
// This program is commercial software. Use of this software is governed
// by your applicable license agreement with FromDual GmbH
//

logMessage(LOG_NOTICE, 'Begin page: ' . basename(__FILE__));

// include('lib/Cluster.inc');

$hFunction  = isset($_REQUEST['f']) ? strval($_REQUEST['f']) : '';
$hClusterId = isset($_REQUEST['cluster_id']) ? intval($_REQUEST['cluster_id']) : 0;

if ( $hFunction == 'add' ) {

  print "<h1>Add new replication</h1>\n";

  $aCluster['cluster_id']   = 0;
  $aCluster['name'] = 'Master/Slave Replication';
  $aCluster['type'] = 1;
}
elseif ( $hFunction == 'edit' ) {

  // list($rc, $dbh) = openRepositoryDatabase();
  if ( $hClusterId > 0 ) {
		list($rc, $aCluster) = getClusterById($dbh, $hClusterId);
  	// closeRepositoryDatabase($dbh);
	}

  print '<h1>Edit Replication ' . $aCluster['name'] . "</h1>\n";

}
else {
  $rc = 942;
	$msg = "Error (rc=$rc).";
  print "<p>$msg</p>\n";
	logMessage(LOG_ERR, $msg);
  exit($rc);
}

// print "<pre>"; print_r($aCluster); print "</pre>";

?>

<script src="js/node.check_for_safe.js"></script>

<form action="index.php" method="post">

<table border="0" cellpadding="3" cellspacing="0">
  <tr>
    <td>Replication name:</td>
    <td><input type="text" name="name" value="<?php print $aCluster['name']; ?>" /></td>
  </tr>
  <tr>
    <td>Cluster type:</td>
    <td>
      <?php
      $aClusterTypes = getClusterTypes();
      ?>
      <select name="type" id="MasterSlaveType" onchange="myToggle();">
        <?php
        foreach ( $aClusterTypes as $cluster_type_id => $value ) {
          $selected = '';
          if ( $cluster_type_id == $aCluster['type'] ) {
            $selected = 'selected="selected"';
          }
          $disabled = '';
          if ( $cluster_type_id != MASTER_SLAVE ) {
            $disabled='disabled="disabled"';
          }
          print "<option value='" . $cluster_type_id . "' $selected $disabled >" . $value . "</option>\n";
        }
        ?>
      </select>
    </td>
  </tr>
  <?php

  list($rc, $dbh) = openRepositoryDatabase();
  list($rc, $aNodes) = getAllDatabaseNodes($dbh);
  if ( $hFunction == 'edit' ) {
    list($rc, $aMasterIds) = getMastersOfReplication($dbh, $aCluster['cluster_id']);
    // print "<pre>"; print_r($aMasterIds); print "</pre>";
    list($rc, $aSlaveIds) = getSlavesOfMasterSlaveReplication($dbh, $aCluster['cluster_id']);
    // print "<pre>"; print_r($aSlaveIds); print "</pre>";
  }
  closeRepositoryDatabase($dbh);

  ?>
  <tr>
    <?php
    // M/M Replication
 /*   $no = '';
    if ( $aCluster['type'] == 2 ) {
 */     $no = ' 1';
//     }
    ?>
    <td>Master<?php // print $no; ?>:</td>
    <td>
      <select name="master_id[]">
        <option value='0'>none</option>
        <?php
        foreach ( $aNodes as $node ) {
          $selected = '';
          if ( isset($aMasterIds[0]) && ($node['node_id'] == $aMasterIds[0]) ) {
            $selected = ' selected="selected"';
          }
          print "<option value='" . $node['node_id'] . "' $selected >" . $node['name'] . "</option>\n";
        }
        ?>
      </select>
    </td>
  </tr>
  <?php

  // if ( $aCluster['type'] == 2 ) {
    ?>

    <tr id="master2">
      <td>Master 2:</td>
      <td>
        <select name="master_id[]">
          <?php
          print "<option value='0'>none</option>\n";
          foreach ( $aNodes as $node ) {
            $selected = '';
            if ( isset($aMasterIds[1]) && ($node['node_id'] == $aMasterIds[1]) ) {
              $selected = ' selected="selected"';
            }
            print "<option value='" . $node['node_id'] . "' $selected >" . $node['name'] . "</option>\n";
          }
          ?>
        </select>
      </td>
    </tr>
    <?php
//  }

  if ( $gMode == 'demo' ) {
    ?>
    <tr>
      <td>Slaves:</td>
      <td><input type="button" value="autodetect" disabled="disabled" title="For production release only" /></td>
    </tr>
    <?php
  }

  for ( $i = 0; $i <= 2; $i++ ) {
    ?>
    <tr>
      <td><?php if ( $i == 0 ) { print "Slaves:"; } ?></td>
      <td>
        <select name="slave_id[]">
        <?php
        print "<option value='0'>none</option>";
        foreach ( $aNodes as $node ) {
          $selected = '';
          if ( isset($aSlaveIds[$i]) && ($node['node_id'] == $aSlaveIds[$i]) ) {
            $selected = ' selected="selected"';
          }
          print "<option value='" . $node['node_id'] . "'$selected>" . $node['name'] . "</option>\n";
        }
        ?>
        </select>
      </td>
    </tr>
    <?php
  }

  ?>
  <tr><td></td><td>&nbsp;</td></tr>
  <tr>
    <td></td>
    <td>
    <?php

    if ( $hFunction == 'edit' ) {
      print "<input type='submit' value='Safe' />";
    }
    elseif ( $hFunction == 'add' ) {
      print "<input type='submit' value='Create' />";
    }

    print "&nbsp;<input type='button' value='Back' onclick='window.history.back();'></td>\n";
    ?>
		</td>
  </tr>
</table>

<script>
// Default is Master/Slave
document.getElementById('master2').style.visibility='hidden';
</script>

<input type="hidden" name="o" value="replication" />
<input type="hidden" name="f" value="safe" />
<input type="hidden" name="t" value="replication" />
<input type="hidden" name="cluster_id" value="<?php print $aCluster['cluster_id']; ?>" />

</form>

<?php

logMessage(LOG_NOTICE, 'End page: ' . basename(__FILE__));

?>
