<?php

//
// Copyright (C) 2013, 2014 FromDual GmbH
//
// This program is commercial software. Use of this software is governed
// by your applicable license agreement with FromDual GmbH
//

print "<h1>Safe Server " . $aServer['name']. "</h1>\n";
list($rc, $dbh) = openRepositoryDatabase();

// print "<pre>"; print_r($aServer); print "</pre>";

// Check for empty server name
if ( $aServer['name'] == '' ) {
  print "<p>Server name cannot be empty. ERR.</p>\n";
  exit;
}

$err = 0;

// Do those checks only when a new server is added
// todo: in fact it should be rechecked with an edited server!!!
if ( $aServer['server_id'] == 0 ) {
  // todo: this is buggy, we have to expect several servers with same name
  // but there should be only one server with a specific name.
  // Check server name
  list($ret, $aTest) = getServerByName($dbh, $aServer['name']);
  if ( count($aTest) == 0 ) {
    print "<p>Server name does NOT exist yet: <span style='color: green;'><strong>OK</strong></span>.</p>\n";
  }
  else {
    $err++;
    print "<p>Server name ALREADY exists: <span style='color: red;'><strong>ERR</strong></span>.</p>\n";
  }

  // Check ip_address
  list($ret, $aTest) = getServerByIpAddress($dbh, $aServer['default_ip']);
  if ( count($aTest) == 0 ) {
    print "<p>Server IP address does NOT exist yet: <span style='color: green;'><strong>OK</strong></span>.</p>\n";
  }
  else {
    $err++;
    print "<p>Server IP address ALREADY exists: <span style='color: red;'><strong>ERR</strong></span>.</p>\n";
  }
}

// Only safe if no errors
if ( $err == OK ) {

  // Server add
  if ( $aServer['server_id'] == 0 ) {
    list($rc, $server_id) = addServer($dbh, $aServer);
    $aServer['server_id'] = $server_id;
  }
  // Server edit
  else {
    list($ret, $msg) = setServer($dbh, $aServer);
    if ( $ret != 0 ) {
      $rc = 771;
      print "<p>ERROR: " . $msg . "(rc=$rc, ret=$ret).</p>\n";
    }
  }
  ?>
  <p>Server safed successfully.</p>
  <input type="button" value="Continue" onclick="window.location='index.php?f=show&amp;o=server&amp;s=configuration&amp;server_id=<?php print $aServer['server_id']; ?>';" />
  <?php
}
else {
  ?>
  <p>Saving failed. Please fix the problem first.</p>
  <p><input type="button" value="Back" onClick="window.history.back();" /></p>
  <?php
}

closeRepositoryDatabase($dbh);

?>
